const Mesa = require('vendor/Mesa.js');

/**
 * A Mesa Script exports a class with a script() method.
 */
module.exports = new class {

  /**
   * Mesa Script
   *
   * @param {object} payload The payload data
   * @param {object} context Additional context about this task
   */
  script = (payload, context) => {
    let vars = context.steps;

    let variantAirtable = vars.custom_1;
    let variantShopify = vars.loop;

    let options = {
      "headers": {
        "Content-Type": "application\/json",
        "Authorization": "Bearer " + Mesa.credential.get('airtable'),
      }
    }

    let base = context.steps.transform.base;
    let table = 'Variants';
    let url = 'https://api.airtable.com/v0/' + base + '/' + table + '/' + variantAirtable.id;

    let data = {
      "fields": {
        "Price": parseFloat(variantShopify.price),
        "Compare At": variantShopify.compare_at_price ? parseFloat(variantShopify.compare_at_price) : 0,
      }
    };
    Mesa.log.info("variantShopify", variantShopify);

    Mesa.log.info("data", data);
    
    let result = Mesa.request.patch(url, data, options);
    Mesa.log.info('result', result);
    if (result.error) {
        throw new Error("Airtable error: " + JSON.stringify(result.error))
    }

    Mesa.output.next(result);
  }
}
